# LAVA: Least Authority Virtual Architecture

LAVA use submodules for project management. After cloning the repository,
run the following command:
``` bash
make submodules
```

## Repositories

- [llvm-lava](llvm-lava/): The implementation of the LAVA VM
  instrumentation passes and SoftCaps slicing with call gate
  security instrumentation.

  - lava-loader: PCG

- [objenc](objenc/): A Whole-Program Privilege and Compartmentalization Analysis. It transform the source code into a program capability graph(PCG). 
  - Metrics from paper? 
    - EAR
    - Indirect Influence Data Flows
  - ePCG

- [taintflowpath](taintflowpath/): A LLVM implementation designed to trace specific paths from source to sink, utilizing the Program Dependence Graph (PDG) to monitor the flow of tainted data.

  - Label sources
  - Label sinks
  - Get all forward slices from sources (if no sinks
    specified)
  - Get all backwards-slices from sinks to inputs (if no
    sources specified)
  - Get paths between sinks and sources

  TODO: Figure out what we want the interfaces to be

  - There's a graph search algorithm on the IR or PDG
    directly

- [augmentation](): An interface to agument.
  - ???

- [libsanity](libsanity/): A LLVM implementation aimed at detecting the unchecked pattern for size variables utilized in memory operations, leveraging the LLVM Static Single Assignment(SSA) form

- [memorizer](memorizer/): An inline access monitor embedded in the Linux kernel, it traces alloc, free, call, return, load, and store operations within the Linux kernel.

- [libmemorizer](libmemorizer/): An userspace access monitor.

- [papers](papers/): Published papers, please refer to the paper for data generated by each
  tool.

## Examples and Status

- [x] nginx 1.23.1
- [x] ffmpeg 6.1

## Build and Run

### Docker (Recommended)

LAVA utilize `docker` containers to compile and run LAVA and several examples.
To build all the examples, simply run the following command:
``` bash
make examples
```

### Manual

See [Manual](MANUAL.md).

### Roadmap

- GraphDB Transformations: LAVA VM is LLVM IR and MC
  modifications. Plan: src->LLVM->.bc + llvm-ir -> graphdb
  -> modifies the llvm-IR directly and saves back ?
    - creating an updater that respects the LLVM-IR types
      etc and that can export back to the LLVM IR.
    - NEEDS DESIGN
